﻿using UnityEngine;
using System.Collections;
using System;

public class SmoothCamera2D : MonoBehaviour, IObserver<CharacterEventArgs>
{
    public float dampTime = 0.15f;
    private Vector3 velocity = Vector3.zero;
    public Transform target;

    private Camera _camera;
    public Camera Cam
    {
        get
        {
            if (_camera == null)
                _camera = GetComponent<Camera>();

            return _camera;
        }
    }
    
    void Update()
    {
        if (target)
        {
            Vector3 point = Cam.WorldToViewportPoint(target.position);
            Vector3 delta = target.position - Cam.ViewportToWorldPoint(new Vector3(0.5f, 0.5f, point.z)); //(new Vector3(0.5, 0.5, point.z));
            Vector3 destination = transform.position + delta;
            transform.position = Vector3.SmoothDamp(transform.position, destination, ref velocity, dampTime);
        }

    }

    public void HandleEvent(object sender, CharacterEventArgs e)
    {
        if(e.EventType == CharacterEventType.TakeDamage || e.EventType == CharacterEventType.Died)
        {
            iTween.PunchPosition(gameObject, Vector3.one, 0.5f);
        }
    }
}