﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class EyeBehavior : MonoBehaviour {

    public float dist = 0.1f;
    Vector3 startPos = Vector3.zero;
    public Transform _target;

    private SpriteRenderer _sprite;
    public SpriteRenderer Sprite
    {
        get
        {
            if (_sprite == null)
                _sprite = GetComponent<SpriteRenderer>();

            return _sprite;
        }
    }

    public void Start()
    {
        startPos = transform.localPosition;
    }
    
    public void LookAt(Transform target)
    {
        _target = target;
    }

    void Update()
    {
        if(_target != null)
        {
            Vector3 dir = (_target.transform.position - transform.position).normalized;
            dir = transform.InverseTransformDirection(dir);
            dir = dir * dist;
            transform.localPosition = startPos + dir;
        }
        else
        {
            transform.localPosition = startPos;
        }
    }

    public void Visible(bool value)
    {
        if (!Sprite)
            return;

        if(value)
        {
            Color c = Sprite.color;
            c.a = 1.0f;
            Sprite.color = c;
        }
        else
        {
            Color c = Sprite.color;
            c.a = 0.0f;
            Sprite.color = c;
        }
    }

}
