﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SpawnerBehavior : MonoBehaviour {

    public GameObject Prefab;
    public float spawnTimer = 3.0f;
    public int MaxCount = 3;
    
    float timer = 0.0f;
    List<SpawnableBehavior> Spawned = new List<SpawnableBehavior>();

    public void Update()
    {
        if (Spawned.Count >= MaxCount)
            return;
        
        timer += Time.deltaTime;
        if(timer > spawnTimer)
        {
            if (Vector3.Distance(GameManagerBehavior.curret.Player.transform.position, transform.position) > 10.0f)
            {
                timer = 0.0f;
                Spawn();
            }
            else
            {
                timer = spawnTimer / 2.0f;
            }   
        }   
    }
    
    void Start()
    {
        Spawn();
    }

    public void Reset()
    {
        for (int i = Spawned.Count - 1; i >= 0; i--)
        {
            Spawned[i].Despawn();
        }
    }

    public void Spawn()
    {
        GameObject ob = Instantiate(Prefab);
        ob.transform.position = transform.position += new Vector3(Random.Range(-5.0f, 5.0f), Random.Range(-5.0f, 5.0f), 0.0f);
        SpawnableBehavior s = ob.GetComponent<SpawnableBehavior>();
        s.Spawn(this);
        Spawned.Add(s);
    }

    public void Despawn(SpawnableBehavior spawnable)
    {
        if (Spawned.Contains(spawnable))
            Spawned.Remove(spawnable);
    }
}
