﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerControlBehavior : MonoBehaviour
{
    public GameObject tapEffectPrefab;
    public float SplashRate = 3.0f; // hits per second

    bool canSplash = true;
    float sTimer = 0.0f;

    void Update()
    {
        if (Time.timeScale == 0.0f || !GameManagerBehavior.curret.isRunning)
            return;

        if (!canSplash)
            SplashDelay();

        if (Input.GetButtonDown("Fire1"))
        {
            Vector3 tapPoint = Input.mousePosition;
            tapPoint.z = 10;

            tapPoint = Camera.main.ScreenToWorldPoint( tapPoint);

            if(Vector3.Distance(GameManagerBehavior.curret.Player.transform.position, tapPoint) > 0.5f)
                Splash(tapPoint);
        }

        if(Input.GetKeyDown(KeyCode.Escape))
        {
            QuitGamePress();
        }
    }
    
    public void QuitGamePress()
    {
        UIManager ui = FindObjectOfType<UIManager>();
        if(ui != null && !ui.ConfirmW.gameObject.activeInHierarchy)
            ui.ConfirmW.Show("Quit the game?", delegate (bool val) { if (val) Application.Quit(); });
    }

    public void Splash(Vector3 tapPoint)
    {


        if (canSplash)
        {
            canSplash = false;
            if (tapEffectPrefab)
            {
                GameObject obj = Instantiate(tapEffectPrefab);
                obj.transform.position = new Vector3(tapPoint.x, tapPoint.y, 0.0f);
            }
            else
                Debug.LogWarning("TapEffect prefab not assigned!");
        }
    }

    void SplashDelay()
    {
        sTimer += Time.deltaTime;
        if (sTimer > (1.0f / SplashRate))
        {
            sTimer = 0.0f;
            canSplash = true;
        }
    }
}
