﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class EnemyFleeState : BaseState<EnemyBehavior>
{
    CharacterBehavior _target;
    Vector3 targetDirection;

    public EnemyFleeState(Transform target)
    {
        Debug.Log(target.name);
        _target = target.GetComponent<CharacterBehavior>();
    }
    
    public override void Update(EnemyBehavior Owner)
    {
        if(_target == null || !_target.alive)
        {
            Owner.ChangeState(new EnemyIdleState());
            return;
        }

        float dist = Vector3.Distance(Owner.transform.position, _target.transform.position);
        if(dist < Owner.LineOfSight * 2.0f)
        {
            targetDirection = -(_target.transform.position - Owner.transform.position).normalized;
            Owner.Move(targetDirection);
        }
        else
        {
            Owner.ChangeState(new EnemyIdleState());
        }
    }
    
}
