﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public delegate void OnConfirmDelegate(bool val);
public class ConfirmWindow : MonoBehaviour
{
    public OnConfirmDelegate onConfirmEvent;
    public void Show(string message, OnConfirmDelegate onConfirm)
    {
        Time.timeScale = 0.0f;

        onConfirmEvent = onConfirm;
        
        if(!gameObject.activeInHierarchy)
            gameObject.SetActive(true);
    }  

    public void Confirm()
    {
        if (onConfirmEvent != null)
            onConfirmEvent(true);

        Hide();
    }

    public void Cancel()
    {
        if (onConfirmEvent != null)
            onConfirmEvent(false);

        Hide();
    }
    
    void Hide()
    {
        Time.timeScale = 1.0f;

        if (gameObject.activeInHierarchy)
            gameObject.SetActive(false);
    }
}
