﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class GameHUD : MonoBehaviour, IObserver<CharacterEventArgs>, IObserver<GameEventArgs>
{
    public Sprite FullHeart;
    public Sprite EmptyHeart;

    public Transform HeartContainer;
    private Image[] _hearts;
    public Image[] Hearts
    {
        get
        {
            if(HeartContainer != null)
            {
                _hearts = HeartContainer.GetComponentsInChildren<Image>();
            }
            return _hearts;
        }
    }
    
    public void HandleEvent(object sender, CharacterEventArgs e)
    {
        CharacterBehavior c = (CharacterBehavior)sender;
        UpdateHealth(c.Health);  
    }
    public void HandleEvent(object sender, GameEventArgs e)
    {
        if(e.EventType == GameEvents.ScoreUpdate)
        {
            GameManagerBehavior gm = (GameManagerBehavior)sender;
            UpdateScore(gm.Score);
        }
    }

    void UpdateScore(int score)
    {
        Debug.Log("score: " + score);
    }

    void UpdateHealth(int health)
    {
        if (!FullHeart || !EmptyHeart)
        {
            Debug.LogError("Missing full or empty heart sprite from hud");
        }
        
        for (int i = 0; i < Hearts.Length; i++)
        {
            if (i + 1 <= health)
                Hearts[i].sprite = FullHeart;
            else
                Hearts[i].sprite = EmptyHeart;
        }
    }

    
}
