﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ExplosiveForceBehaviour : MonoBehaviour {

	public List<GameObject> enemies;
	public GameObject player;

	public float explosionForce;

	public void AddEnemy(GameObject e) {
		enemies.Add(e);
	}

	public void RemoveEnemy(GameObject e) {
		enemies.Remove(e);
	}

	public void CreateExplosionAt(Vector2 pos) {

		Vector2 forceDirection = Vector2.zero;

		foreach(GameObject o in enemies) {
			forceDirection = new Vector2(o.transform.position.x, o.transform.position.y) - pos;
			o.GetComponent<Rigidbody2D>().AddForceAtPosition(forceDirection*explosionForce, pos);
		}
	}


}
