﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SceneTransitionButton : MonoBehaviour {

	public string targetScene;
	private AudioSource snd;
	private Animator anim;
	public ShutterController shutter;

	void Start() {
		snd = gameObject.GetComponent<AudioSource>();
		anim = gameObject.GetComponentInParent<Animator>();
	}

	public void PressButton() {
		Debug.Log("START TRANSITION");
		Invoke("ChangeScene", 1.5f);
		if (snd != null) {
			snd.Play();
		}
		if (anim != null) {
			anim.Play("TitleClickAnim");
		}
		shutter.CloseShutter();

	}

	void OnMouseUp() {
		PressButton();
	}

	void ChangeScene() {
		UnityEngine.SceneManagement.SceneManager.LoadScene(targetScene);
	}
}
