﻿using UnityEngine;
using System.Collections;

public class StateChase : IEnemyState 

{

	private readonly StatePatternEnemy enemy;


	public StateChase (StatePatternEnemy statePatternEnemy)
	{
		enemy = statePatternEnemy;
	}

	public void UpdateState()
	{
		Chase ();
	}

	public void OnTriggerEnter (Collider2D other)
	{
	}

	public void OnTriggerExit (Collider2D other)
	{
		if (other.gameObject.CompareTag ("Player")) {
			ToIdleState ();

		}
	}

	public void ToIdleState()
	{
		Debug.Log ("CHANGE STATE: Idle.");
		enemy.GetComponentInChildren<SpriteRenderer>().color = enemy.idleColor;
		enemy.currentState = enemy.idleState;
		enemy.chaseTarget = null;
		//enemy.GetComponentInChildren<Animator>().Play(enemy.idleAnim);
	}
		
	public void ToChaseState()
	{
		Debug.Log ("Can't transition to same state");
	}


	private void Chase()
	{
		Vector2 targetDirection = enemy.chaseTarget.position - enemy.transform.position;
		enemy.mover.Move(targetDirection.normalized);
	}


}