﻿using UnityEngine;
using System.Collections;

public class StateIdle : IEnemyState 

{
	private readonly StatePatternEnemy enemy;
	private int nextWayPoint;

	public StateIdle (StatePatternEnemy statePatternEnemy)
	{
		enemy = statePatternEnemy;
	}

	public void UpdateState()
	{
		Move ();
	}

	public void OnTriggerEnter (Collider2D other)
	{
		if (other.gameObject.CompareTag ("Player")) {
			enemy.chaseTarget = other.transform;
			ToChaseState ();
		}
	}

	public void OnTriggerExit (Collider2D other)
	{
		/*
		if (other.gameObject.CompareTag ("Player")) {
			ToIdleState ();
			enemy.chaseTarget = null;
		}*/
	}

	public void ToIdleState()
	{
		Debug.Log ("Can't transition to same state");
	}

	public void ToChaseState()
	{
		Debug.Log ("CHANGE STATE: Chase!");
		enemy.GetComponentInChildren<SpriteRenderer>().color = enemy.chaseColor;
		enemy.GetComponentInChildren<Animator>().Play(enemy.chaseAnim);
		enemy.currentState = enemy.chaseState;
	}
		
	void Move ()
	{
		//Idle around

		Vector2 randomVector = new Vector2(Random.value -0.5f, Random.value -0.5f);
		randomVector = randomVector.normalized;

		enemy.mover.Move(randomVector);

	}
}