﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class TapShockwaveBehaviour : MonoBehaviour {

	public float explosionForce;
    
    public LayerMask hitmask;
    public AnimationCurve waveCurve;

    public float distance = 1.0f;
    public float duration = 0.5f;
    float timer = 0.0f;

    public void Awake()
    {
        timer = 0.0f;
    }

    public void FixedUpdate()
    {
        if (timer > duration)
            return;

        timer += Time.fixedDeltaTime;
        float dist = distance * waveCurve.Evaluate(timer / duration);    

        Collider2D[] col = Physics2D.OverlapCircleAll(transform.position, dist, hitmask);
        for (int i = 0; i < col.Length; i++)
        {
            Transform root = col[i].transform.root;
            Rigidbody2D rb = root.GetComponent<Rigidbody2D>();

            Vector3 dir = (rb.transform.position - transform.position).normalized;
            rb.AddForce(dir * explosionForce);
        }
    }

	//void OnTriggerEnter2D(Collider2D col) {

	//	if (col.isTrigger) {
	//		Debug.Log("TRIGGER HIT");
	//		return;
	//	}
	//	Debug.Log("WAVE HIT");

 //       Transform t = col.transform.root;
 //       MoverBehavior m = t.GetComponent<MoverBehavior>();
 //       if(m)
 //       {
 //           Vector2 originPosition = new Vector2(transform.position.x, transform.position.y);
 //           Vector2 forceDirection = new Vector2((col.transform.position.x - originPosition.x), (col.transform.position.y - originPosition.y));
	//		float forceDistance = Mathf.Clamp(forceDirection.magnitude, 1.0f, 1000.0f);

	//		m.RB.AddForce(forceDirection.normalized * explosionForce / forceDistance, ForceMode2D.Impulse);
 //       }
	//}
}